Log Time fieldset in IssueController#edit doesn't set default Activity as default
2008-05-26 14:59 - Simone Carletti

Status: Closed Start date: 2008-05-26
Priority: Normal Due date:

Assignee: % Done: 100%
Category: Time tracking Estimated time: 0.00 hour
Target version: 0.7.2

Resolution: Fixed Affected version: 0.7.1
Description

Even if you specified a default activity from /enumerations administration area, the edit issue controller always displays @activities
without being aware of any settings.
The select tag always set the first item as the default.

I made a quick search (I can't provide a patch right now, perhaps I'll do when I'll be less busy) and here's some details you can use to
debug the problem:

/views/issues/edit.rhtml
<div class="splitcontentright">
<p><%= time_entry.select :activity_id, (Qactivities.collect {|p| [p.name, p.id]l}) %></p>
</div>

time_entry instance default :activity_id should be set to @activities default activity id.

/controllers/issue_controller.rb

if request.get?

@custom_values = (@project.custom_fields_for_issues(@issue.tracker) .collect { |x]| @issue.cust
om_values.find_by_custom_field_id(x.id) || CustomValue.new(:custom_field => x, :customized => @iss
ue) }

else

# Update custom fields if user has :edit permission
if @edit_allowed && params|[:custom_fields]

@custom_values = @project.custom_fields_for_issues(@issue.tracker).collect { |x| CustomVal
ue.new (:custom_field => x, :customized => @issue, :value => params["custom_fields"][x.id.to_s]) }
@issue.custom_values = (@custom_values
end

| would probably add here, within the request.get? conditional statement, a default value for new @time_entry values.

Associated revisions

Revision 1461 - 2008-05-26 19:12 - Jean-Philippe Lang
Fixed: IssueController#edit doesn't set default Activity as default (#1302).

Revision 1533 - 2008-06-14 14:31 - Jean-Philippe Lang

Fixed: time entries created with the default activity even if a different one is specified (#1302).

History

#1 - 2008-05-26 19:10 - Jean-Philippe Lang

- Category changed from Issues to Time tracking
- Status changed from New to Closed

- Target version setto 0.7.2

- Resolution set to Fixed

Fixed in r1461.
https://www.redmine.org/projects/redmine/repository/svn/revisions/1461

| fixed it at model level rather than in the controller. But thanks for pointing out the problem.

#2 - 2008-05-26 20:25 - rupert thurner
- % Done changed from 0 to 100

#3 - 2008-06-13 17:58 - Nobuhiro IMAI
- File fix-time_entry-initialization.diff added

- Status changed from Closed to Reopened

After this change, new TimeEntry is always saved with default ACTI, even when

the another activity_id was sent from browser.
This is Rails fanon :-).

>> Foo.belongs_to :bar
>> Bar.has_one :foo

>> foo = Foo.new

>> foo.bar = Bar.find (1)
>> foo.bar_id

=> 1

>> foo.bar_id = 2

>> foo.bar_id

=> 2

>> foo.save

=> true

>> foo.bar_id

=> 1

The attached patch will fix this problem, | guess.

Thanks,

#4 - 2008-06-14 14:27 - Jean-Philippe Lang

- Status changed from Reopened to Closed

Fixed in r1533. Thanks.

Files
